#pragma once

#include <stddef.h>

namespace gp{
	template <typename range, typename F>
	void indexed_foreach(range n, F f) {
		for(size_t idx = 0; idx < n.size(); ++idx)
		{
			f(idx, n[idx]);
		}
	}

	template <typename range, typename F>
	void foreach(range n, F f) {
		for(auto& elem : n)
		{
			f(elem);
		}
	}

	template <typename range, typename T>
	void fill(range& range_v, T value) {
		for(auto& elem : range_v) {
			elem = value;
		}
	}
}