#pragma once

#include "gp/containers/vector.hpp"
#include "gp/dynamic/compiler/type/base_type.hpp"
#include "gp/utils/allocators/allocator.hpp"

using string = gp::vector<char>;

struct gr_type {
    gr_base_type base_type;

    string mangled_type;
    string mangled_return_type;

    bool is_field;

    gr_type(gr_base_type base, gp::allocator& alloc)
    : base_type(base)
    , mangled_type(alloc)
    , mangled_return_type(alloc)
    {}

    gr_type(gr_base_type base, string mangled_name, gp::allocator& alloc)
    : base_type(base)
    , mangled_type(alloc)
    , mangled_return_type(alloc)
    {
        mangled_type = mangled_name;
    }
};